using System;
using System.Drawing;
using System.Collections;
using System.IO;
using System.ComponentModel;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;
using Microsoft.Win32;
using FlickrNet;

namespace Clipr
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class CliprForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox picImage;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnUpload;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button btnOptions;
		private System.Windows.Forms.TextBox tbFilename;
		private System.Windows.Forms.GroupBox gbDetails;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tbDescription;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox tbTitle;
		private System.Windows.Forms.Label lblTags;
		private System.Windows.Forms.TextBox tbTags;
		private System.Windows.Forms.CheckBox cbPublic;
		private System.Windows.Forms.CheckBox cbFamily;
		private System.Windows.Forms.CheckBox cbFriend;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button btnAbout;

		Image _image;

		public CliprForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.picImage = new System.Windows.Forms.PictureBox();
			this.label1 = new System.Windows.Forms.Label();
			this.btnUpload = new System.Windows.Forms.Button();
			this.tbFilename = new System.Windows.Forms.TextBox();
			this.btnOptions = new System.Windows.Forms.Button();
			this.gbDetails = new System.Windows.Forms.GroupBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.tbDescription = new System.Windows.Forms.TextBox();
			this.btnClose = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.tbTitle = new System.Windows.Forms.TextBox();
			this.lblTags = new System.Windows.Forms.Label();
			this.tbTags = new System.Windows.Forms.TextBox();
			this.cbPublic = new System.Windows.Forms.CheckBox();
			this.cbFamily = new System.Windows.Forms.CheckBox();
			this.cbFriend = new System.Windows.Forms.CheckBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnAbout = new System.Windows.Forms.Button();
			this.gbDetails.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// picImage
			// 
			this.picImage.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.picImage.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.picImage.Location = new System.Drawing.Point(16, 32);
			this.picImage.Name = "picImage";
			this.picImage.Size = new System.Drawing.Size(368, 160);
			this.picImage.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
			this.picImage.TabIndex = 0;
			this.picImage.TabStop = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(336, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Clipboard image:";
			// 
			// btnUpload
			// 
			this.btnUpload.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnUpload.Location = new System.Drawing.Point(304, 216);
			this.btnUpload.Name = "btnUpload";
			this.btnUpload.Size = new System.Drawing.Size(80, 23);
			this.btnUpload.TabIndex = 9;
			this.btnUpload.Text = "&Upload Now";
			this.btnUpload.Click += new System.EventHandler(this.btnUpload_Click);
			// 
			// tbFilename
			// 
			this.tbFilename.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbFilename.Location = new System.Drawing.Point(16, 80);
			this.tbFilename.Name = "tbFilename";
			this.tbFilename.Size = new System.Drawing.Size(240, 20);
			this.tbFilename.TabIndex = 4;
			this.tbFilename.Text = "";
			// 
			// btnOptions
			// 
			this.btnOptions.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOptions.Location = new System.Drawing.Point(304, 248);
			this.btnOptions.Name = "btnOptions";
			this.btnOptions.Size = new System.Drawing.Size(80, 23);
			this.btnOptions.TabIndex = 10;
			this.btnOptions.Text = "&Options";
			this.btnOptions.Click += new System.EventHandler(this.btnOptions_Click);
			// 
			// gbDetails
			// 
			this.gbDetails.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gbDetails.Controls.Add(this.lblTags);
			this.gbDetails.Controls.Add(this.tbTags);
			this.gbDetails.Controls.Add(this.label4);
			this.gbDetails.Controls.Add(this.tbTitle);
			this.gbDetails.Controls.Add(this.label3);
			this.gbDetails.Controls.Add(this.tbDescription);
			this.gbDetails.Controls.Add(this.label2);
			this.gbDetails.Controls.Add(this.tbFilename);
			this.gbDetails.Location = new System.Drawing.Point(16, 208);
			this.gbDetails.Name = "gbDetails";
			this.gbDetails.Size = new System.Drawing.Size(272, 256);
			this.gbDetails.TabIndex = 5;
			this.gbDetails.TabStop = false;
			this.gbDetails.Text = "Image Details";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(144, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "F&ilename (ie., MyCat.jpg):";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 184);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(144, 16);
			this.label3.TabIndex = 7;
			this.label3.Text = "&Description:";
			// 
			// tbDescription
			// 
			this.tbDescription.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbDescription.Location = new System.Drawing.Point(16, 200);
			this.tbDescription.Multiline = true;
			this.tbDescription.Name = "tbDescription";
			this.tbDescription.Size = new System.Drawing.Size(240, 40);
			this.tbDescription.TabIndex = 8;
			this.tbDescription.Text = "";
			// 
			// btnClose
			// 
			this.btnClose.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnClose.Location = new System.Drawing.Point(304, 312);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(80, 23);
			this.btnClose.TabIndex = 12;
			this.btnClose.Text = "&Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 24);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(144, 16);
			this.label4.TabIndex = 1;
			this.label4.Text = "&Title:";
			// 
			// tbTitle
			// 
			this.tbTitle.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbTitle.Location = new System.Drawing.Point(16, 40);
			this.tbTitle.Name = "tbTitle";
			this.tbTitle.Size = new System.Drawing.Size(240, 20);
			this.tbTitle.TabIndex = 2;
			this.tbTitle.Text = "";
			this.tbTitle.Leave += new System.EventHandler(this.tbTitle_Leave);
			// 
			// lblTags
			// 
			this.lblTags.Location = new System.Drawing.Point(16, 110);
			this.lblTags.Name = "lblTags";
			this.lblTags.Size = new System.Drawing.Size(144, 16);
			this.lblTags.TabIndex = 5;
			this.lblTags.Text = "&Tags:";
			// 
			// tbTags
			// 
			this.tbTags.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbTags.Location = new System.Drawing.Point(16, 126);
			this.tbTags.Name = "tbTags";
			this.tbTags.Size = new System.Drawing.Size(240, 20);
			this.tbTags.TabIndex = 6;
			this.tbTags.Text = "";
			// 
			// cbPublic
			// 
			this.cbPublic.Location = new System.Drawing.Point(16, 24);
			this.cbPublic.Name = "cbPublic";
			this.cbPublic.Size = new System.Drawing.Size(64, 24);
			this.cbPublic.TabIndex = 13;
			this.cbPublic.Text = "&Public";
			// 
			// cbFamily
			// 
			this.cbFamily.Location = new System.Drawing.Point(16, 48);
			this.cbFamily.Name = "cbFamily";
			this.cbFamily.Size = new System.Drawing.Size(64, 24);
			this.cbFamily.TabIndex = 14;
			this.cbFamily.Text = "F&amily";
			// 
			// cbFriend
			// 
			this.cbFriend.Location = new System.Drawing.Point(16, 72);
			this.cbFriend.Name = "cbFriend";
			this.cbFriend.Size = new System.Drawing.Size(64, 24);
			this.cbFriend.TabIndex = 15;
			this.cbFriend.Text = "&Friend";
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Controls.Add(this.cbFriend);
			this.groupBox1.Controls.Add(this.cbFamily);
			this.groupBox1.Controls.Add(this.cbPublic);
			this.groupBox1.Location = new System.Drawing.Point(296, 352);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(88, 112);
			this.groupBox1.TabIndex = 13;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Access";
			// 
			// btnAbout
			// 
			this.btnAbout.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnAbout.Location = new System.Drawing.Point(304, 280);
			this.btnAbout.Name = "btnAbout";
			this.btnAbout.Size = new System.Drawing.Size(80, 23);
			this.btnAbout.TabIndex = 11;
			this.btnAbout.Text = "&About...";
			this.btnAbout.Click += new System.EventHandler(this.btnAbout_Click);
			// 
			// CliprForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 478);
			this.Controls.Add(this.btnAbout);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.gbDetails);
			this.Controls.Add(this.btnOptions);
			this.Controls.Add(this.btnUpload);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.picImage);
			this.Name = "CliprForm";
			this.Text = "Clipr, by Steve Tibbett";
			this.Activated += new System.EventHandler(this.CliprForm_Activated);
			this.gbDetails.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new CliprForm());
		}

		void Post()
		{
			if (tbFilename.Text.Length < 1)
			{
				MessageBox.Show("Please enter a file name.");
				tbFilename.Focus();
				return;
			}

			try
			{
				string tempPath = Path.GetTempPath();
				string tempFile = Path.Combine(tempPath, tbFilename.Text);
				_image.Save(tempFile);

				RegistryKey key = Registry.CurrentUser.CreateSubKey("Software\\Clipr");
				object emailObj = key.GetValue("Email");
				object passwordObj = key.GetValue("Password");

				if (emailObj == null || passwordObj == null)
				{
					MessageBox.Show("Please click Options and enter your account information before posting.");
					return;
				}
				
				string email = emailObj.ToString();
				string password = passwordObj.ToString();

				Flickr f = new Flickr("a3216108b34de4925f9ab75a879a842c", email, password);
				f.UploadPicture(tempFile, tbTitle.Text, tbDescription.Text, tbTags.Text, cbPublic.Checked, cbFamily.Checked, cbFriend.Checked);

			} 
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
				Trace.WriteLine(ex.ToString());
			}
		}

		private void btnUpload_Click(object sender, System.EventArgs e)
		{
			UploadingForm f = new UploadingForm();

			try
			{
				f.Owner = this;
				f.Show();

				Cursor = Cursors.WaitCursor;

				f.Update();

				Post();
			} 
			finally
			{
				Cursor = Cursors.Arrow;

				f.Close();
			}
		}

		// Update the image whenever we're activated
		private void CliprForm_Activated(object sender, System.EventArgs e)
		{
			DataObject data = (DataObject)Clipboard.GetDataObject();
			if (data.GetDataPresent(DataFormats.Bitmap))
			{
				Image i = (Image)data.GetData(DataFormats.Bitmap, true);
				if (i != null)
				{
					_image = i;
					picImage.Image = _image;
				}
			}
		}

		private void btnOptions_Click(object sender, System.EventArgs e)
		{
			OptionsForm options = new OptionsForm();
			options.ShowDialog(this);
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void tbTitle_Leave(object sender, System.EventArgs e)
		{
			if (tbFilename.Text.Length == 0)
			{
				// Create a filename
				StringBuilder sb = new StringBuilder();
				foreach (char ch in tbTitle.Text)
				{
					if (Char.IsLetterOrDigit(ch))
						sb.Append(ch);
				}

				sb.Append(".jpg");
				tbFilename.Text = sb.ToString();
			}
		}

		private void btnAbout_Click(object sender, System.EventArgs e)
		{
			AboutForm f = new AboutForm();
			f.ShowDialog(this);
		}
	}
}
